#include <xvideo.h>
#include <c3.h>
#include <c3blank.h>

extern C3_WREGS	*c3_wreg;
extern C3_RREGS	*c3_rreg;

int C3HBlank= C3HBLANK;
int C3HSync=  C3HSYNC;
int C3VBlank= C3VBLANK;	
int C3VSync=  C3VSYNC;	

SetC3Blanking(hblank,hsync,vblank,vsync) {
        C3HBlank= hblank;
        C3HSync=  hsync;
        C3VBlank= vblank;
        C3VSync=  vsync;
}

SetC3GetImageTiming(width,height,interlaced) {
	C3_WREG(HPeriod,  width + C3HBlank  -1);
	C3_WREG(HSync,    C3HSync);
	C3_WREG(HDelay,   C3HBlank/2);
	C3_WREG(HActive,  2 * (width/8) -1);
	C3_WREG(VSync,    C3VSync);
	C3_WREG(VDelay,   C3VBlank/2);	
	C3_WREG(VActive,  (height/8/(interlaced ? 2 : 1)) );
	C3_WREG(VPeriod,  height/(interlaced ? 2 : 1) + C3VBlank  -1);
	C3_WREG(HControl, 0);
	C3_WREG(VControl, 0);
}

SetC3PutImageTiming(width,height) {
	C3_WREG(HPeriod,  width + C3HBlank  -1);
	C3_WREG(HSync,    C3HSync);
	C3_WREG(HDelay,   C3HBlank/2);
	C3_WREG(HActive,  2 * (width/8) -1);
	C3_WREG(VSync,    C3VSync);
	C3_WREG(VDelay,   C3VBlank/2 - 9); 
	C3_WREG(VPeriod,  height + C3VBlank  -1 );
	C3_WREG(VActive,  (height/8));
	C3_WREG(HControl, ~0);
	C3_WREG(VControl, ~0);
}

