#pragma ident "@(#)plxDga.c	1.2 94/08/28   SMI"

#include "sun.h"
#include <sys/ioccom.h>

#include "dga/dgawinstr.h"
/* #include "dga/dgapixstr.h" */
#include "mibstorest.h"
#include "gcstruct.h"
#include "pixmapstr.h"
#include "mpg/wid.h"
#include "mpg/mpg.h"
#include "windowstr.h"

extern VisualID VIDs[];

#define WindowVisual(w) ((w)->optional? \
			 (w)->optional->visual : \
			 ((w)->parent ? \
			  FindWindowWithOptional(w)->optional->visual : 0))

/* 
 * plxWidSetup(pWin, num)
 * pWin:	Window to allocate wids for
 * num:		Number of wids to allocate.
 *
 */

static int
plxWidSetup(WindowPtr pWin, int num)
{
    ScreenPtr		pScreen;
    mpgPrivWinPtr 	pMpgWin = mpg_priv_win(pWin);
    int			pg = pMpgWin->mpgInfo->did;
    WidPtr		new_wid,wid;
    int			value,rv;
    WXINFO	     	*infop;
    WDEV        	*wdev;
    WindowPtr 		pChild;
    int vid = WindowVisual(pWin);

	DgaSetupWindow(pWin);

	pScreen= pWin->drawable.pScreen;
	wid = widGetWindowWid(pWin);

	/* Allocate Unique WID's */	
	new_wid = widAllocate(pScreen, vid, num, TRUE, 0);
	if (!new_wid) return FALSE;
	/* Not really need now - leave in place if need arises.
	PlxSetWlut(widGetValue(new_wid), 0, PLX_TRUE_COLOR_CLUT, FALSE, 0, 
	 */
		
	widSetWindowWid(pWin, new_wid, TRUE);
	if ( pDgaWindow && (wdev = (WDEV *)pDgaWindow->pDgaWdev)
                && DgaWgCheckGrab(wdev->infop)) {
			infop = (WXINFO *)wdev->infop;
			infop->wx_dbuf.UNIQUE = 1;
			infop->wx_dbuf.WID = widGetValue(new_wid);
/*
			infop->w_number_wids = widGetNumber(new_wid);
    ** This needs	infop->w_start_wid = widGetValue(new_wid);
    ** to be fixed	infop->w_wid = infop->w_start_wid;
*/
	    }
		return TRUE;
}


/*  DgaAvail()
 * DGA_AVAIL_HW_CURS - 	this means that this fb supports DGA and the cursor
 *  		    	on this fb is ALWAYS hw - no switching between sw/hw
 * 		    	rendering ( eg: GT, GS)
 * 
 * DGA_AVAIL_SW_CURS - 	this means that the fb supports DGA and the cursor is
 * 		     	ALWAYS rendered in sw ( eg. cg3)
 * 
 * DGA_AVAIL_HW_SW_CURS -  this means that this fb supports DGA and the cursor
 * 			could sometimes be in hw and sometimes in sw. 
 * 			GX/GX+ is like this.
 * 
 * DGA_NONE -  		this means that this fb does NOT support DGA.
 */ 

static int
plxDgaAvail()
{
    return  (TRUE);
}

/* 
 * plxGrabWindow(pWin, infop)
 * pWin:	Window that's being grabbed
 * infop:	shared stuff
 *
 */
static int
plxGrabWindow(WindowPtr pWin, WXINFO *infop)
{
    mpgPrivWinPtr 	pMpgWin = mpg_priv_win(pWin);
    VisualID		visual;
    extern Bool		dx_client;
    int			pg;


    return TRUE;
}
	


/* 
 * plxUnGrabWindow(pWin, infop)
 * pWin:	Window that's being ungrabbed
 * infop:	shared stuff
 *
 */
static int
plxUnGrabWindow(WindowPtr pWin, WXINFO *infop)
{

    return TRUE;
}
	

/* Declare the DGA ops vector */
DgaDevFuncs	plxDgaFuncs = {
    NULL,	   	/* Set up info for grabbed shared
				   retained window or pixmap */
    NULL,	 	/* Restore the data from shared area to the
				   pixmap when it is ungrabbed */
    NULL,	   	/* Should be DGA DB setup */
    plxWidSetup,		/* Wid setup */
    NULL,			/* FCS NOT SUPPORTED */
    NULL,			/* ZBUF NOT SUPPORTED */
    NULL,			/* stereo setup */
    NULL,			/* Chokefb */
    plxDgaAvail,		/* DgaAvail */
    plxGrabWindow,
    plxUnGrabWindow,
    NULL,				/* DbValidate */
    NULL				/* pCmap, cg_infop */
};

