#ifndef rtv_h_INCLUDED
#define rtv_h_INCLUDED

#include "rtv_ops.h"

#define RTV_MODULE_CONNECTED 1
#define RTV_MODULE_DISCONNECTED 2
#define RTV_MODULE_IDLE 3
#define RTV_MODULE_PLAY 4
#define RTV_MODULE_RECORD 5
#define RTV_MODULE_PAUSE 6

#define RTV_MODULE_FULL_SIZE 1
#define RTV_MODULE_QUARTER_SIZE 0

#define MAX_HOSTNAME_LENGTH 100


typedef struct
{
  int            status;
  RTV_OBJECT*    handle;
  RTV_ATTRIBUTES attributes;
  char*          hostname;
  char*          fileName;
} RTV_STRUCT;

#endif /* rtv_h_INCLUDED */
